import { HTTPClient } from "koajax";
import { components } from "@octokit/openapi-types";
import { ListModel, BaseModel, Filter } from "mobx-restful";
import { PickSingle } from "web-utility";
export const githubClient: HTTPClient<import("koajax").Context>;
export type Organization = components['schemas']['organization'];
declare const OrganizationModel_base: (abstract new (...args: any[]) => {
    stream?: AsyncGenerator<{
        login: string;
        url: string;
        id: number;
        node_id: string;
        repos_url: string;
        events_url: string;
        hooks_url: string;
        issues_url: string;
        members_url: string;
        public_members_url: string;
        avatar_url: string;
        description: string | null;
        blog?: string;
        html_url: string;
        name?: string;
        company?: string;
        location?: string;
        email?: string;
        has_organization_projects: boolean;
        has_repository_projects: boolean;
        is_verified?: boolean;
        public_repos: number;
        public_gists: number;
        followers: number;
        following: number;
        type: string;
        created_at: string;
        updated_at: string;
        plan?: {
            name?: string;
            space?: number;
            private_repos?: number;
            filled_seats?: number;
            seats?: number;
        };
    }, void, any>;
    openStream(filter: Partial<import("mobx-restful").NewData<{
        login: string;
        url: string;
        id: number;
        node_id: string;
        repos_url: string;
        events_url: string;
        hooks_url: string;
        issues_url: string;
        members_url: string;
        public_members_url: string;
        avatar_url: string;
        description: string | null;
        blog?: string;
        html_url: string;
        name?: string;
        company?: string;
        location?: string;
        email?: string;
        has_organization_projects: boolean;
        has_repository_projects: boolean;
        is_verified?: boolean;
        public_repos: number;
        public_gists: number;
        followers: number;
        following: number;
        type: string;
        created_at: string;
        updated_at: string;
        plan?: {
            name?: string;
            space?: number;
            private_repos?: number;
            filled_seats?: number;
            seats?: number;
        };
    }>>): AsyncGenerator<{
        login: string;
        url: string;
        id: number;
        node_id: string;
        repos_url: string;
        events_url: string;
        hooks_url: string;
        issues_url: string;
        members_url: string;
        public_members_url: string;
        avatar_url: string;
        description: string | null;
        blog?: string;
        html_url: string;
        name?: string;
        company?: string;
        location?: string;
        email?: string;
        has_organization_projects: boolean;
        has_repository_projects: boolean;
        is_verified?: boolean;
        public_repos: number;
        public_gists: number;
        followers: number;
        following: number;
        type: string;
        created_at: string;
        updated_at: string;
        plan?: {
            name?: string;
            space?: number;
            private_repos?: number;
            filled_seats?: number;
            seats?: number;
        };
    }, void, any>;
    clearList(): void;
    clear(): void;
    restoreList({ filter, pageIndex, pageSize, allItems, totalCount }?: Partial<Pick<ListModel<{
        login: string;
        url: string;
        id: number;
        node_id: string;
        repos_url: string;
        events_url: string;
        hooks_url: string;
        issues_url: string;
        members_url: string;
        public_members_url: string;
        avatar_url: string;
        description: string | null;
        blog?: string;
        html_url: string;
        name?: string;
        company?: string;
        location?: string;
        email?: string;
        has_organization_projects: boolean;
        has_repository_projects: boolean;
        is_verified?: boolean;
        public_repos: number;
        public_gists: number;
        followers: number;
        following: number;
        type: string;
        created_at: string;
        updated_at: string;
        plan?: {
            name?: string;
            space?: number;
            private_repos?: number;
            filled_seats?: number;
            seats?: number;
        };
    }, Partial<import("mobx-restful").NewData<{
        login: string;
        url: string;
        id: number;
        node_id: string;
        repos_url: string;
        events_url: string;
        hooks_url: string;
        issues_url: string;
        members_url: string;
        public_members_url: string;
        avatar_url: string;
        description: string | null;
        blog?: string;
        html_url: string;
        name?: string;
        company?: string;
        location?: string;
        email?: string;
        has_organization_projects: boolean;
        has_repository_projects: boolean;
        is_verified?: boolean;
        public_repos: number;
        public_gists: number;
        followers: number;
        following: number;
        type: string;
        created_at: string;
        updated_at: string;
        plan?: {
            name?: string;
            space?: number;
            private_repos?: number;
            filled_seats?: number;
            seats?: number;
        };
    }>>>, "filter" | "pageIndex" | "pageSize" | "allItems" | "totalCount">>): Promise<void>;
    loadStream(filter: Partial<import("mobx-restful").NewData<{
        login: string;
        url: string;
        id: number;
        node_id: string;
        repos_url: string;
        events_url: string;
        hooks_url: string;
        issues_url: string;
        members_url: string;
        public_members_url: string;
        avatar_url: string;
        description: string | null;
        blog?: string;
        html_url: string;
        name?: string;
        company?: string;
        location?: string;
        email?: string;
        has_organization_projects: boolean;
        has_repository_projects: boolean;
        is_verified?: boolean;
        public_repos: number;
        public_gists: number;
        followers: number;
        following: number;
        type: string;
        created_at: string;
        updated_at: string;
        plan?: {
            name?: string;
            space?: number;
            private_repos?: number;
            filled_seats?: number;
            seats?: number;
        };
    }>>, newCount: number): Promise<{
        login: string;
        url: string;
        id: number;
        node_id: string;
        repos_url: string;
        events_url: string;
        hooks_url: string;
        issues_url: string;
        members_url: string;
        public_members_url: string;
        avatar_url: string;
        description: string | null;
        blog?: string;
        html_url: string;
        name?: string;
        company?: string;
        location?: string;
        email?: string;
        has_organization_projects: boolean;
        has_repository_projects: boolean;
        is_verified?: boolean;
        public_repos: number;
        public_gists: number;
        followers: number;
        following: number;
        type: string;
        created_at: string;
        updated_at: string;
        plan?: {
            name?: string;
            space?: number;
            private_repos?: number;
            filled_seats?: number;
            seats?: number;
        };
    }[]>;
    loadPage(pageIndex: number, pageSize: number, filter: Partial<import("mobx-restful").NewData<{
        login: string;
        url: string;
        id: number;
        node_id: string;
        repos_url: string;
        events_url: string;
        hooks_url: string;
        issues_url: string;
        members_url: string;
        public_members_url: string;
        avatar_url: string;
        description: string | null;
        blog?: string;
        html_url: string;
        name?: string;
        company?: string;
        location?: string;
        email?: string;
        has_organization_projects: boolean;
        has_repository_projects: boolean;
        is_verified?: boolean;
        public_repos: number;
        public_gists: number;
        followers: number;
        following: number;
        type: string;
        created_at: string;
        updated_at: string;
        plan?: {
            name?: string;
            space?: number;
            private_repos?: number;
            filled_seats?: number;
            seats?: number;
        };
    }>>): Promise<{
        pageData: {
            login: string;
            url: string;
            id: number;
            node_id: string;
            repos_url: string;
            events_url: string;
            hooks_url: string;
            issues_url: string;
            members_url: string;
            public_members_url: string;
            avatar_url: string;
            description: string | null;
            blog?: string;
            html_url: string;
            name?: string;
            company?: string;
            location?: string;
            email?: string;
            has_organization_projects: boolean;
            has_repository_projects: boolean;
            is_verified?: boolean;
            public_repos: number;
            public_gists: number;
            followers: number;
            following: number;
            type: string;
            created_at: string;
            updated_at: string;
            plan?: {
                name?: string;
                space?: number;
                private_repos?: number;
                filled_seats?: number;
                seats?: number;
            };
        }[];
        totalCount: number;
    }>;
    pageIndex: number;
    pageSize: number;
    filter: Partial<import("mobx-restful").NewData<{
        login: string;
        url: string;
        id: number;
        node_id: string;
        repos_url: string;
        events_url: string;
        hooks_url: string;
        issues_url: string;
        members_url: string;
        public_members_url: string;
        avatar_url: string;
        description: string | null;
        blog?: string;
        html_url: string;
        name?: string;
        company?: string;
        location?: string;
        email?: string;
        has_organization_projects: boolean;
        has_repository_projects: boolean;
        is_verified?: boolean;
        public_repos: number;
        public_gists: number;
        followers: number;
        following: number;
        type: string;
        created_at: string;
        updated_at: string;
        plan?: {
            name?: string;
            space?: number;
            private_repos?: number;
            filled_seats?: number;
            seats?: number;
        };
    }>>;
    totalCount: number | undefined;
    pageList: {
        login: string;
        url: string;
        id: number;
        node_id: string;
        repos_url: string;
        events_url: string;
        hooks_url: string;
        issues_url: string;
        members_url: string;
        public_members_url: string;
        avatar_url: string;
        description: string | null;
        blog?: string;
        html_url: string;
        name?: string;
        company?: string;
        location?: string;
        email?: string;
        has_organization_projects: boolean;
        has_repository_projects: boolean;
        is_verified?: boolean;
        public_repos: number;
        public_gists: number;
        followers: number;
        following: number;
        type: string;
        created_at: string;
        updated_at: string;
        plan?: {
            name?: string;
            space?: number;
            private_repos?: number;
            filled_seats?: number;
            seats?: number;
        };
    }[][];
    readonly currentPage: {
        login: string;
        url: string;
        id: number;
        node_id: string;
        repos_url: string;
        events_url: string;
        hooks_url: string;
        issues_url: string;
        members_url: string;
        public_members_url: string;
        avatar_url: string;
        description: string | null;
        blog?: string;
        html_url: string;
        name?: string;
        company?: string;
        location?: string;
        email?: string;
        has_organization_projects: boolean;
        has_repository_projects: boolean;
        is_verified?: boolean;
        public_repos: number;
        public_gists: number;
        followers: number;
        following: number;
        type: string;
        created_at: string;
        updated_at: string;
        plan?: {
            name?: string;
            space?: number;
            private_repos?: number;
            filled_seats?: number;
            seats?: number;
        };
    }[];
    readonly pageCount: number;
    readonly allItems: {
        login: string;
        url: string;
        id: number;
        node_id: string;
        repos_url: string;
        events_url: string;
        hooks_url: string;
        issues_url: string;
        members_url: string;
        public_members_url: string;
        avatar_url: string;
        description: string | null;
        blog?: string;
        html_url: string;
        name?: string;
        company?: string;
        location?: string;
        email?: string;
        has_organization_projects: boolean;
        has_repository_projects: boolean;
        is_verified?: boolean;
        public_repos: number;
        public_gists: number;
        followers: number;
        following: number;
        type: string;
        created_at: string;
        updated_at: string;
        plan?: {
            name?: string;
            space?: number;
            private_repos?: number;
            filled_seats?: number;
            seats?: number;
        };
    }[];
    readonly noMore: boolean;
    statistic: Partial<Record<import("web-utility").TypeKeys<{
        login: string;
        url: string;
        id: number;
        node_id: string;
        repos_url: string;
        events_url: string;
        hooks_url: string;
        issues_url: string;
        members_url: string;
        public_members_url: string;
        avatar_url: string;
        description: string | null;
        blog?: string;
        html_url: string;
        name?: string;
        company?: string;
        location?: string;
        email?: string;
        has_organization_projects: boolean;
        has_repository_projects: boolean;
        is_verified?: boolean;
        public_repos: number;
        public_gists: number;
        followers: number;
        following: number;
        type: string;
        created_at: string;
        updated_at: string;
        plan?: {
            name?: string;
            space?: number;
            private_repos?: number;
            filled_seats?: number;
            seats?: number;
        };
    }, import("web-utility").IndexKey>, Record<string, number>>>;
    turnTo(pageIndex: number, pageSize?: number): ListModel<{
        login: string;
        url: string;
        id: number;
        node_id: string;
        repos_url: string;
        events_url: string;
        hooks_url: string;
        issues_url: string;
        members_url: string;
        public_members_url: string;
        avatar_url: string;
        description: string | null;
        blog?: string;
        html_url: string;
        name?: string;
        company?: string;
        location?: string;
        email?: string;
        has_organization_projects: boolean;
        has_repository_projects: boolean;
        is_verified?: boolean;
        public_repos: number;
        public_gists: number;
        followers: number;
        following: number;
        type: string;
        created_at: string;
        updated_at: string;
        plan?: {
            name?: string;
            space?: number;
            private_repos?: number;
            filled_seats?: number;
            seats?: number;
        };
    }, Partial<import("mobx-restful").NewData<{
        login: string;
        url: string;
        id: number;
        node_id: string;
        repos_url: string;
        events_url: string;
        hooks_url: string;
        issues_url: string;
        members_url: string;
        public_members_url: string;
        avatar_url: string;
        description: string | null;
        blog?: string;
        html_url: string;
        name?: string;
        company?: string;
        location?: string;
        email?: string;
        has_organization_projects: boolean;
        has_repository_projects: boolean;
        is_verified?: boolean;
        public_repos: number;
        public_gists: number;
        followers: number;
        following: number;
        type: string;
        created_at: string;
        updated_at: string;
        plan?: {
            name?: string;
            space?: number;
            private_repos?: number;
            filled_seats?: number;
            seats?: number;
        };
    }>>>;
    loadNewPage(pageIndex: number, pageSize: number, filter: Partial<import("mobx-restful").NewData<{
        login: string;
        url: string;
        id: number;
        node_id: string;
        repos_url: string;
        events_url: string;
        hooks_url: string;
        issues_url: string;
        members_url: string;
        public_members_url: string;
        avatar_url: string;
        description: string | null;
        blog?: string;
        html_url: string;
        name?: string;
        company?: string;
        location?: string;
        email?: string;
        has_organization_projects: boolean;
        has_repository_projects: boolean;
        is_verified?: boolean;
        public_repos: number;
        public_gists: number;
        followers: number;
        following: number;
        type: string;
        created_at: string;
        updated_at: string;
        plan?: {
            name?: string;
            space?: number;
            private_repos?: number;
            filled_seats?: number;
            seats?: number;
        };
    }>>): Promise<{
        pageData: {
            login: string;
            url: string;
            id: number;
            node_id: string;
            repos_url: string;
            events_url: string;
            hooks_url: string;
            issues_url: string;
            members_url: string;
            public_members_url: string;
            avatar_url: string;
            description: string | null;
            blog?: string;
            html_url: string;
            name?: string;
            company?: string;
            location?: string;
            email?: string;
            has_organization_projects: boolean;
            has_repository_projects: boolean;
            is_verified?: boolean;
            public_repos: number;
            public_gists: number;
            followers: number;
            following: number;
            type: string;
            created_at: string;
            updated_at: string;
            plan?: {
                name?: string;
                space?: number;
                private_repos?: number;
                filled_seats?: number;
                seats?: number;
            };
        }[];
        totalCount: number;
    }>;
    getList(filter?: Partial<import("mobx-restful").NewData<{
        login: string;
        url: string;
        id: number;
        node_id: string;
        repos_url: string;
        events_url: string;
        hooks_url: string;
        issues_url: string;
        members_url: string;
        public_members_url: string;
        avatar_url: string;
        description: string | null;
        blog?: string;
        html_url: string;
        name?: string;
        company?: string;
        location?: string;
        email?: string;
        has_organization_projects: boolean;
        has_repository_projects: boolean;
        is_verified?: boolean;
        public_repos: number;
        public_gists: number;
        followers: number;
        following: number;
        type: string;
        created_at: string;
        updated_at: string;
        plan?: {
            name?: string;
            space?: number;
            private_repos?: number;
            filled_seats?: number;
            seats?: number;
        };
    }>>, pageIndex?: number, pageSize?: number): Promise<{
        login: string;
        url: string;
        id: number;
        node_id: string;
        repos_url: string;
        events_url: string;
        hooks_url: string;
        issues_url: string;
        members_url: string;
        public_members_url: string;
        avatar_url: string;
        description: string | null;
        blog?: string;
        html_url: string;
        name?: string;
        company?: string;
        location?: string;
        email?: string;
        has_organization_projects: boolean;
        has_repository_projects: boolean;
        is_verified?: boolean;
        public_repos: number;
        public_gists: number;
        followers: number;
        following: number;
        type: string;
        created_at: string;
        updated_at: string;
        plan?: {
            name?: string;
            space?: number;
            private_repos?: number;
            filled_seats?: number;
            seats?: number;
        };
    }[]>;
    refreshList(): Promise<{
        login: string;
        url: string;
        id: number;
        node_id: string;
        repos_url: string;
        events_url: string;
        hooks_url: string;
        issues_url: string;
        members_url: string;
        public_members_url: string;
        avatar_url: string;
        description: string | null;
        blog?: string;
        html_url: string;
        name?: string;
        company?: string;
        location?: string;
        email?: string;
        has_organization_projects: boolean;
        has_repository_projects: boolean;
        is_verified?: boolean;
        public_repos: number;
        public_gists: number;
        followers: number;
        following: number;
        type: string;
        created_at: string;
        updated_at: string;
        plan?: {
            name?: string;
            space?: number;
            private_repos?: number;
            filled_seats?: number;
            seats?: number;
        };
    }[]>;
    getAll(filter?: Partial<import("mobx-restful").NewData<{
        login: string;
        url: string;
        id: number;
        node_id: string;
        repos_url: string;
        events_url: string;
        hooks_url: string;
        issues_url: string;
        members_url: string;
        public_members_url: string;
        avatar_url: string;
        description: string | null;
        blog?: string;
        html_url: string;
        name?: string;
        company?: string;
        location?: string;
        email?: string;
        has_organization_projects: boolean;
        has_repository_projects: boolean;
        is_verified?: boolean;
        public_repos: number;
        public_gists: number;
        followers: number;
        following: number;
        type: string;
        created_at: string;
        updated_at: string;
        plan?: {
            name?: string;
            space?: number;
            private_repos?: number;
            filled_seats?: number;
            seats?: number;
        };
    }>>, pageSize?: number): Promise<{
        login: string;
        url: string;
        id: number;
        node_id: string;
        repos_url: string;
        events_url: string;
        hooks_url: string;
        issues_url: string;
        members_url: string;
        public_members_url: string;
        avatar_url: string;
        description: string | null;
        blog?: string;
        html_url: string;
        name?: string;
        company?: string;
        location?: string;
        email?: string;
        has_organization_projects: boolean;
        has_repository_projects: boolean;
        is_verified?: boolean;
        public_repos: number;
        public_gists: number;
        followers: number;
        following: number;
        type: string;
        created_at: string;
        updated_at: string;
        plan?: {
            name?: string;
            space?: number;
            private_repos?: number;
            filled_seats?: number;
            seats?: number;
        };
    }[]>;
    countAll(keys: import("web-utility").TypeKeys<{
        login: string;
        url: string;
        id: number;
        node_id: string;
        repos_url: string;
        events_url: string;
        hooks_url: string;
        issues_url: string;
        members_url: string;
        public_members_url: string;
        avatar_url: string;
        description: string | null;
        blog?: string;
        html_url: string;
        name?: string;
        company?: string;
        location?: string;
        email?: string;
        has_organization_projects: boolean;
        has_repository_projects: boolean;
        is_verified?: boolean;
        public_repos: number;
        public_gists: number;
        followers: number;
        following: number;
        type: string;
        created_at: string;
        updated_at: string;
        plan?: {
            name?: string;
            space?: number;
            private_repos?: number;
            filled_seats?: number;
            seats?: number;
        };
    }, import("web-utility").IndexKey>[], filter?: Partial<import("mobx-restful").NewData<{
        login: string;
        url: string;
        id: number;
        node_id: string;
        repos_url: string;
        events_url: string;
        hooks_url: string;
        issues_url: string;
        members_url: string;
        public_members_url: string;
        avatar_url: string;
        description: string | null;
        blog?: string;
        html_url: string;
        name?: string;
        company?: string;
        location?: string;
        email?: string;
        has_organization_projects: boolean;
        has_repository_projects: boolean;
        is_verified?: boolean;
        public_repos: number;
        public_gists: number;
        followers: number;
        following: number;
        type: string;
        created_at: string;
        updated_at: string;
        plan?: {
            name?: string;
            space?: number;
            private_repos?: number;
            filled_seats?: number;
            seats?: number;
        };
    }>>, pageSize?: number): Promise<Partial<Record<import("web-utility").TypeKeys<{
        login: string;
        url: string;
        id: number;
        node_id: string;
        repos_url: string;
        events_url: string;
        hooks_url: string;
        issues_url: string;
        members_url: string;
        public_members_url: string;
        avatar_url: string;
        description: string | null;
        blog?: string;
        html_url: string;
        name?: string;
        company?: string;
        location?: string;
        email?: string;
        has_organization_projects: boolean;
        has_repository_projects: boolean;
        is_verified?: boolean;
        public_repos: number;
        public_gists: number;
        followers: number;
        following: number;
        type: string;
        created_at: string;
        updated_at: string;
        plan?: {
            name?: string;
            space?: number;
            private_repos?: number;
            filled_seats?: number;
            seats?: number;
        };
    }, import("web-utility").IndexKey>, Record<string, number>>>>;
    indexOf(id: import("mobx-restful").IDType): number;
    changeOne(data: Partial<{
        login: string;
        url: string;
        id: number;
        node_id: string;
        repos_url: string;
        events_url: string;
        hooks_url: string;
        issues_url: string;
        members_url: string;
        public_members_url: string;
        avatar_url: string;
        description: string | null;
        blog?: string;
        html_url: string;
        name?: string;
        company?: string;
        location?: string;
        email?: string;
        has_organization_projects: boolean;
        has_repository_projects: boolean;
        is_verified?: boolean;
        public_repos: number;
        public_gists: number;
        followers: number;
        following: number;
        type: string;
        created_at: string;
        updated_at: string;
        plan?: {
            name?: string;
            space?: number;
            private_repos?: number;
            filled_seats?: number;
            seats?: number;
        };
    }>, id: import("mobx-restful").IDType, patch?: boolean): void;
    updateOne(data: Partial<import("mobx-restful").NewData<{
        login: string;
        url: string;
        id: number;
        node_id: string;
        repos_url: string;
        events_url: string;
        hooks_url: string;
        issues_url: string;
        members_url: string;
        public_members_url: string;
        avatar_url: string;
        description: string | null;
        blog?: string;
        html_url: string;
        name?: string;
        company?: string;
        location?: string;
        email?: string;
        has_organization_projects: boolean;
        has_repository_projects: boolean;
        is_verified?: boolean;
        public_repos: number;
        public_gists: number;
        followers: number;
        following: number;
        type: string;
        created_at: string;
        updated_at: string;
        plan?: {
            name?: string;
            space?: number;
            private_repos?: number;
            filled_seats?: number;
            seats?: number;
        };
    }>>, id?: import("mobx-restful").IDType): Promise<{
        login: string;
        url: string;
        id: number;
        node_id: string;
        repos_url: string;
        events_url: string;
        hooks_url: string;
        issues_url: string;
        members_url: string;
        public_members_url: string;
        avatar_url: string;
        description: string | null;
        blog?: string;
        html_url: string;
        name?: string;
        company?: string;
        location?: string;
        email?: string;
        has_organization_projects: boolean;
        has_repository_projects: boolean;
        is_verified?: boolean;
        public_repos: number;
        public_gists: number;
        followers: number;
        following: number;
        type: string;
        created_at: string;
        updated_at: string;
        plan?: {
            name?: string;
            space?: number;
            private_repos?: number;
            filled_seats?: number;
            seats?: number;
        };
    }>;
    removeOne(id: import("mobx-restful").IDType): Promise<void>;
    deleteOne(id: import("mobx-restful").IDType): Promise<void>;
    client: import("mobx-restful").RESTClient;
    baseURI: string;
    indexKey: "login" | "url" | "id" | "node_id" | "repos_url" | "events_url" | "hooks_url" | "issues_url" | "members_url" | "public_members_url" | "avatar_url" | "description" | "blog" | "html_url" | "name" | "company" | "location" | "email" | "has_organization_projects" | "has_repository_projects" | "is_verified" | "public_repos" | "public_gists" | "followers" | "following" | "type" | "created_at" | "updated_at" | "plan";
    currentOne: {
        login: string;
        url: string;
        id: number;
        node_id: string;
        repos_url: string;
        events_url: string;
        hooks_url: string;
        issues_url: string;
        members_url: string;
        public_members_url: string;
        avatar_url: string;
        description: string | null;
        blog?: string;
        html_url: string;
        name?: string;
        company?: string;
        location?: string;
        email?: string;
        has_organization_projects: boolean;
        has_repository_projects: boolean;
        is_verified?: boolean;
        public_repos: number;
        public_gists: number;
        followers: number;
        following: number;
        type: string;
        created_at: string;
        updated_at: string;
        plan?: {
            name?: string;
            space?: number;
            private_repos?: number;
            filled_seats?: number;
            seats?: number;
        };
    };
    clearCurrent(): void;
    getOne(id: import("mobx-restful").IDType): Promise<{
        login: string;
        url: string;
        id: number;
        node_id: string;
        repos_url: string;
        events_url: string;
        hooks_url: string;
        issues_url: string;
        members_url: string;
        public_members_url: string;
        avatar_url: string;
        description: string | null;
        blog?: string;
        html_url: string;
        name?: string;
        company?: string;
        location?: string;
        email?: string;
        has_organization_projects: boolean;
        has_repository_projects: boolean;
        is_verified?: boolean;
        public_repos: number;
        public_gists: number;
        followers: number;
        following: number;
        type: string;
        created_at: string;
        updated_at: string;
        plan?: {
            name?: string;
            space?: number;
            private_repos?: number;
            filled_seats?: number;
            seats?: number;
        };
    }>;
    downloading: number;
    uploading: number;
}) & import("web-utility").AbstractClass<ListModel<{
    login: string;
    url: string;
    id: number;
    node_id: string;
    repos_url: string;
    events_url: string;
    hooks_url: string;
    issues_url: string;
    members_url: string;
    public_members_url: string;
    avatar_url: string;
    description: string | null;
    blog?: string;
    html_url: string;
    name?: string;
    company?: string;
    location?: string;
    email?: string;
    has_organization_projects: boolean;
    has_repository_projects: boolean;
    is_verified?: boolean;
    public_repos: number;
    public_gists: number;
    followers: number;
    following: number;
    type: string;
    created_at: string;
    updated_at: string;
    plan?: {
        name?: string;
        space?: number;
        private_repos?: number;
        filled_seats?: number;
        seats?: number;
    };
}, Partial<import("mobx-restful").NewData<{
    login: string;
    url: string;
    id: number;
    node_id: string;
    repos_url: string;
    events_url: string;
    hooks_url: string;
    issues_url: string;
    members_url: string;
    public_members_url: string;
    avatar_url: string;
    description: string | null;
    blog?: string;
    html_url: string;
    name?: string;
    company?: string;
    location?: string;
    email?: string;
    has_organization_projects: boolean;
    has_repository_projects: boolean;
    is_verified?: boolean;
    public_repos: number;
    public_gists: number;
    followers: number;
    following: number;
    type: string;
    created_at: string;
    updated_at: string;
    plan?: {
        name?: string;
        space?: number;
        private_repos?: number;
        filled_seats?: number;
        seats?: number;
    };
}>>>>;
export class OrganizationModel extends OrganizationModel_base {
    client: import("koajax").HTTPClient<import("koajax").Context>;
    baseURI: string;
    openStream(): AsyncGenerator<{
        login: string;
        url: string;
        id: number;
        node_id: string;
        repos_url: string;
        events_url: string;
        hooks_url: string;
        issues_url: string;
        members_url: string;
        public_members_url: string;
        avatar_url: string;
        description: string | null;
        blog?: string;
        html_url: string;
        name?: string;
        company?: string;
        location?: string;
        email?: string;
        has_organization_projects: boolean;
        has_repository_projects: boolean;
        is_verified?: boolean;
        public_repos: number;
        public_gists: number;
        followers: number;
        following: number;
        type: string;
        created_at: string;
        updated_at: string;
        plan?: {
            name?: string;
            space?: number;
            private_repos?: number;
            filled_seats?: number;
            seats?: number;
        };
    }, void, undefined>;
    getOne(name: string): Promise<{
        login: string;
        url: string;
        id: number;
        node_id: string;
        repos_url: string;
        events_url: string;
        hooks_url: string;
        issues_url: string;
        members_url: string;
        public_members_url: string;
        avatar_url: string;
        description: string | null;
        blog?: string;
        html_url: string;
        name?: string;
        company?: string;
        location?: string;
        email?: string;
        has_organization_projects: boolean;
        has_repository_projects: boolean;
        is_verified?: boolean;
        public_repos: number;
        public_gists: number;
        followers: number;
        following: number;
        type: string;
        created_at: string;
        updated_at: string;
        plan?: {
            name?: string;
            space?: number;
            private_repos?: number;
            filled_seats?: number;
            seats?: number;
        };
    }>;
}
export type User = components['schemas']['public-user'];
export class UserModel extends BaseModel {
    client: import("koajax").HTTPClient<import("koajax").Context>;
    accessor session: User | undefined;
    organizationStore: OrganizationModel;
    get namespaces(): ({
        login: string;
        url: string;
        id: number;
        node_id: string;
        repos_url: string;
        events_url: string;
        hooks_url: string;
        issues_url: string;
        members_url: string;
        public_members_url: string;
        avatar_url: string;
        description: string | null;
        blog?: string;
        html_url: string;
        name?: string;
        company?: string;
        location?: string;
        email?: string;
        has_organization_projects: boolean;
        has_repository_projects: boolean;
        is_verified?: boolean;
        public_repos: number;
        public_gists: number;
        followers: number;
        following: number;
        type: string;
        created_at: string;
        updated_at: string;
        plan?: {
            name?: string;
            space?: number;
            private_repos?: number;
            filled_seats?: number;
            seats?: number;
        };
    } | {
        login: string;
        id: number;
        node_id: string;
        avatar_url: string;
        gravatar_id: string | null;
        url: string;
        html_url: string;
        followers_url: string;
        following_url: string;
        gists_url: string;
        starred_url: string;
        subscriptions_url: string;
        organizations_url: string;
        repos_url: string;
        events_url: string;
        received_events_url: string;
        type: string;
        site_admin: boolean;
        name: string | null;
        company: string | null;
        blog: string | null;
        location: string | null;
        email: string | null;
        hireable: boolean | null;
        bio: string | null;
        twitter_username?: string | null;
        public_repos: number;
        public_gists: number;
        followers: number;
        following: number;
        created_at: string;
        updated_at: string;
        plan?: {
            collaborators: number;
            name: string;
            space: number;
            private_repos: number;
        };
        suspended_at?: string | null;
        private_gists?: number;
        total_private_repos?: number;
        owned_private_repos?: number;
        disk_usage?: number;
        collaborators?: number;
    })[];
    getSession(): Promise<{
        login: string;
        id: number;
        node_id: string;
        avatar_url: string;
        gravatar_id: string | null;
        url: string;
        html_url: string;
        followers_url: string;
        following_url: string;
        gists_url: string;
        starred_url: string;
        subscriptions_url: string;
        organizations_url: string;
        repos_url: string;
        events_url: string;
        received_events_url: string;
        type: string;
        site_admin: boolean;
        name: string | null;
        company: string | null;
        blog: string | null;
        location: string | null;
        email: string | null;
        hireable: boolean | null;
        bio: string | null;
        twitter_username?: string | null;
        public_repos: number;
        public_gists: number;
        followers: number;
        following: number;
        created_at: string;
        updated_at: string;
        plan?: {
            collaborators: number;
            name: string;
            space: number;
            private_repos: number;
        };
        suspended_at?: string | null;
        private_gists?: number;
        total_private_repos?: number;
        owned_private_repos?: number;
        disk_usage?: number;
        collaborators?: number;
    }>;
}
type Repository = components['schemas']['minimal-repository'];
export type Contributor = components['schemas']['contributor'];
export type Issue = components['schemas']['issue'];
export interface GitRepository extends Repository {
    contributors?: Contributor[];
    languages?: string[];
    issues?: Issue[];
}
export type GitFile = components['schemas']['content-file'];
export type GitContent = PickSingle<components['schemas']['content-directory']>;
export interface RepositoryFilter extends Filter<GitRepository> {
    relation: (keyof RepositoryModel['relation'])[];
}
type ReturnMap<T> = {
    [K in keyof T]: T[K] extends (...data: any[]) => Promise<any> ? Awaited<ReturnType<T[K]>> : T[K] extends (...data: any[]) => any ? ReturnType<T[K]> : never;
};
export class RepositoryModel extends ListModel<GitRepository, RepositoryFilter> {
    owner: string;
    client: import("koajax").HTTPClient<import("koajax").Context>;
    baseURI: string;
    indexKey: "full_name";
    constructor(owner?: string);
    organizationStore: OrganizationModel;
    relation: {
        contributors: ((URI: string) => Promise<{
            login?: string;
            id?: number;
            node_id?: string;
            avatar_url?: string;
            gravatar_id?: string | null;
            url?: string;
            html_url?: string;
            followers_url?: string;
            following_url?: string;
            gists_url?: string;
            starred_url?: string;
            subscriptions_url?: string;
            organizations_url?: string;
            repos_url?: string;
            events_url?: string;
            received_events_url?: string;
            type: string;
            site_admin?: boolean;
            contributions: number;
            email?: string;
            name?: string;
        }[]>) & import("lodash").MemoizedFunction;
        issues: ((URI: string) => Promise<{
            id: number;
            node_id: string;
            url: string;
            repository_url: string;
            labels_url: string;
            comments_url: string;
            events_url: string;
            html_url: string;
            number: number;
            state: string;
            state_reason?: "completed" | "reopened" | "not_planned" | null;
            title: string;
            body?: string | null;
            user: components["schemas"]["nullable-simple-user"];
            labels: import("@octokit/openapi-types").OneOf<[string, {
                id?: number;
                node_id?: string;
                url?: string;
                name?: string;
                description?: string | null;
                color?: string | null;
                default?: boolean;
            }]>[];
            assignee: components["schemas"]["nullable-simple-user"];
            assignees?: components["schemas"]["simple-user"][] | null;
            milestone: components["schemas"]["nullable-milestone"];
            locked: boolean;
            active_lock_reason?: string | null;
            comments: number;
            pull_request?: {
                merged_at?: string | null;
                diff_url: string | null;
                html_url: string | null;
                patch_url: string | null;
                url: string | null;
            };
            closed_at: string | null;
            created_at: string;
            updated_at: string;
            draft?: boolean;
            closed_by?: components["schemas"]["nullable-simple-user"];
            body_html?: string;
            body_text?: string;
            timeline_url?: string;
            repository?: components["schemas"]["repository"];
            performed_via_github_app?: components["schemas"]["nullable-integration"];
            author_association: components["schemas"]["author-association"];
            reactions?: components["schemas"]["reaction-rollup"];
        }[]>) & import("lodash").MemoizedFunction;
        languages: ((URI: string) => Promise<string[]>) & import("lodash").MemoizedFunction;
    };
    getOneRelation(URI: string, relation?: RepositoryFilter['relation']): Promise<ReturnMap<{
        contributors: ((URI: string) => Promise<{
            login?: string;
            id?: number;
            node_id?: string;
            avatar_url?: string;
            gravatar_id?: string | null;
            url?: string;
            html_url?: string;
            followers_url?: string;
            following_url?: string;
            gists_url?: string;
            starred_url?: string;
            subscriptions_url?: string;
            organizations_url?: string;
            repos_url?: string;
            events_url?: string;
            received_events_url?: string;
            type: string;
            site_admin?: boolean;
            contributions: number;
            email?: string;
            name?: string;
        }[]>) & import("lodash").MemoizedFunction;
        issues: ((URI: string) => Promise<{
            id: number;
            node_id: string;
            url: string;
            repository_url: string;
            labels_url: string;
            comments_url: string;
            events_url: string;
            html_url: string;
            number: number;
            state: string;
            state_reason?: "completed" | "reopened" | "not_planned" | null;
            title: string;
            body?: string | null;
            user: components["schemas"]["nullable-simple-user"];
            labels: import("@octokit/openapi-types").OneOf<[string, {
                id?: number;
                node_id?: string;
                url?: string;
                name?: string;
                description?: string | null;
                color?: string | null;
                default?: boolean;
            }]>[];
            assignee: components["schemas"]["nullable-simple-user"];
            assignees?: components["schemas"]["simple-user"][] | null;
            milestone: components["schemas"]["nullable-milestone"];
            locked: boolean;
            active_lock_reason?: string | null;
            comments: number;
            pull_request?: {
                merged_at?: string | null;
                diff_url: string | null;
                html_url: string | null;
                patch_url: string | null;
                url: string | null;
            };
            closed_at: string | null;
            created_at: string;
            updated_at: string;
            draft?: boolean;
            closed_by?: components["schemas"]["nullable-simple-user"];
            body_html?: string;
            body_text?: string;
            timeline_url?: string;
            repository?: components["schemas"]["repository"];
            performed_via_github_app?: components["schemas"]["nullable-integration"];
            author_association: components["schemas"]["author-association"];
            reactions?: components["schemas"]["reaction-rollup"];
        }[]>) & import("lodash").MemoizedFunction;
        languages: ((URI: string) => Promise<string[]>) & import("lodash").MemoizedFunction;
    }>>;
    getOne(URI: string, relation?: RepositoryFilter['relation']): Promise<{
        contributors: {
            login?: string;
            id?: number;
            node_id?: string;
            avatar_url?: string;
            gravatar_id?: string | null;
            url?: string;
            html_url?: string;
            followers_url?: string;
            following_url?: string;
            gists_url?: string;
            starred_url?: string;
            subscriptions_url?: string;
            organizations_url?: string;
            repos_url?: string;
            events_url?: string;
            received_events_url?: string;
            type: string;
            site_admin?: boolean;
            contributions: number;
            email?: string;
            name?: string;
        }[];
        issues: {
            id: number;
            node_id: string;
            url: string;
            repository_url: string;
            labels_url: string;
            comments_url: string;
            events_url: string;
            html_url: string;
            number: number;
            state: string;
            state_reason?: "completed" | "reopened" | "not_planned" | null;
            title: string;
            body?: string | null;
            user: components["schemas"]["nullable-simple-user"];
            labels: import("@octokit/openapi-types").OneOf<[string, {
                id?: number;
                node_id?: string;
                url?: string;
                name?: string;
                description?: string | null;
                color?: string | null;
                default?: boolean;
            }]>[];
            assignee: components["schemas"]["nullable-simple-user"];
            assignees?: components["schemas"]["simple-user"][] | null;
            milestone: components["schemas"]["nullable-milestone"];
            locked: boolean;
            active_lock_reason?: string | null;
            comments: number;
            pull_request?: {
                merged_at?: string | null;
                diff_url: string | null;
                html_url: string | null;
                patch_url: string | null;
                url: string | null;
            };
            closed_at: string | null;
            created_at: string;
            updated_at: string;
            draft?: boolean;
            closed_by?: components["schemas"]["nullable-simple-user"];
            body_html?: string;
            body_text?: string;
            timeline_url?: string;
            repository?: components["schemas"]["repository"];
            performed_via_github_app?: components["schemas"]["nullable-integration"];
            author_association: components["schemas"]["author-association"];
            reactions?: components["schemas"]["reaction-rollup"];
        }[];
        languages: string[];
        id: number;
        node_id: string;
        name: string;
        full_name: string;
        owner: components["schemas"]["simple-user"];
        private: boolean;
        html_url: string;
        description: string | null;
        fork: boolean;
        url: string;
        archive_url: string;
        assignees_url: string;
        blobs_url: string;
        branches_url: string;
        collaborators_url: string;
        comments_url: string;
        commits_url: string;
        compare_url: string;
        contents_url: string;
        contributors_url: string;
        deployments_url: string;
        downloads_url: string;
        events_url: string;
        forks_url: string;
        git_commits_url: string;
        git_refs_url: string;
        git_tags_url: string;
        git_url?: string;
        issue_comment_url: string;
        issue_events_url: string;
        issues_url: string;
        keys_url: string;
        labels_url: string;
        languages_url: string;
        merges_url: string;
        milestones_url: string;
        notifications_url: string;
        pulls_url: string;
        releases_url: string;
        ssh_url?: string;
        stargazers_url: string;
        statuses_url: string;
        subscribers_url: string;
        subscription_url: string;
        tags_url: string;
        teams_url: string;
        trees_url: string;
        clone_url?: string;
        mirror_url?: string | null;
        hooks_url: string;
        svn_url?: string;
        homepage?: string | null;
        language?: string | null;
        forks_count?: number;
        stargazers_count?: number;
        watchers_count?: number;
        size?: number;
        default_branch?: string;
        open_issues_count?: number;
        is_template?: boolean;
        topics?: string[];
        has_issues?: boolean;
        has_projects?: boolean;
        has_wiki?: boolean;
        has_pages?: boolean;
        has_downloads?: boolean;
        has_discussions?: boolean;
        archived?: boolean;
        disabled?: boolean;
        visibility?: string;
        pushed_at?: string | null;
        created_at?: string | null;
        updated_at?: string | null;
        permissions?: {
            admin?: boolean;
            maintain?: boolean;
            push?: boolean;
            triage?: boolean;
            pull?: boolean;
        };
        role_name?: string;
        temp_clone_token?: string;
        delete_branch_on_merge?: boolean;
        subscribers_count?: number;
        network_count?: number;
        code_of_conduct?: components["schemas"]["code-of-conduct"];
        license?: {
            key?: string;
            name?: string;
            spdx_id?: string;
            url?: string;
            node_id?: string;
        } | null;
        forks?: number;
        open_issues?: number;
        watchers?: number;
        allow_forking?: boolean;
        web_commit_signoff_required?: boolean;
        security_and_analysis?: components["schemas"]["security-and-analysis"];
    }>;
    loadPage(page: number, per_page: number, { relation }: RepositoryFilter): Promise<{
        pageData: {
            contributors: {
                login?: string;
                id?: number;
                node_id?: string;
                avatar_url?: string;
                gravatar_id?: string | null;
                url?: string;
                html_url?: string;
                followers_url?: string;
                following_url?: string;
                gists_url?: string;
                starred_url?: string;
                subscriptions_url?: string;
                organizations_url?: string;
                repos_url?: string;
                events_url?: string;
                received_events_url?: string;
                type: string;
                site_admin?: boolean;
                contributions: number;
                email?: string;
                name?: string;
            }[];
            issues: {
                id: number;
                node_id: string;
                url: string;
                repository_url: string;
                labels_url: string;
                comments_url: string;
                events_url: string;
                html_url: string;
                number: number;
                state: string;
                state_reason?: "completed" | "reopened" | "not_planned" | null;
                title: string;
                body?: string | null;
                user: components["schemas"]["nullable-simple-user"];
                labels: import("@octokit/openapi-types").OneOf<[string, {
                    id?: number;
                    node_id?: string;
                    url?: string;
                    name?: string;
                    description?: string | null;
                    color?: string | null;
                    default?: boolean;
                }]>[];
                assignee: components["schemas"]["nullable-simple-user"];
                assignees?: components["schemas"]["simple-user"][] | null;
                milestone: components["schemas"]["nullable-milestone"];
                locked: boolean;
                active_lock_reason?: string | null;
                comments: number;
                pull_request?: {
                    merged_at?: string | null;
                    diff_url: string | null;
                    html_url: string | null;
                    patch_url: string | null;
                    url: string | null;
                };
                closed_at: string | null;
                created_at: string;
                updated_at: string;
                draft?: boolean;
                closed_by?: components["schemas"]["nullable-simple-user"];
                body_html?: string;
                body_text?: string;
                timeline_url?: string;
                repository?: components["schemas"]["repository"];
                performed_via_github_app?: components["schemas"]["nullable-integration"];
                author_association: components["schemas"]["author-association"];
                reactions?: components["schemas"]["reaction-rollup"];
            }[];
            languages: string[];
            id: number;
            node_id: string;
            name: string;
            full_name: string;
            owner: components["schemas"]["simple-user"];
            private: boolean;
            html_url: string;
            description: string | null;
            fork: boolean;
            url: string;
            archive_url: string;
            assignees_url: string;
            blobs_url: string;
            branches_url: string;
            collaborators_url: string;
            comments_url: string;
            commits_url: string;
            compare_url: string;
            contents_url: string;
            contributors_url: string;
            deployments_url: string;
            downloads_url: string;
            events_url: string;
            forks_url: string;
            git_commits_url: string;
            git_refs_url: string;
            git_tags_url: string;
            git_url?: string;
            issue_comment_url: string;
            issue_events_url: string;
            issues_url: string;
            keys_url: string;
            labels_url: string;
            languages_url: string;
            merges_url: string;
            milestones_url: string;
            notifications_url: string;
            pulls_url: string;
            releases_url: string;
            ssh_url?: string;
            stargazers_url: string;
            statuses_url: string;
            subscribers_url: string;
            subscription_url: string;
            tags_url: string;
            teams_url: string;
            trees_url: string;
            clone_url?: string;
            mirror_url?: string | null;
            hooks_url: string;
            svn_url?: string;
            homepage?: string | null;
            language?: string | null;
            forks_count?: number;
            stargazers_count?: number;
            watchers_count?: number;
            size?: number;
            default_branch?: string;
            open_issues_count?: number;
            is_template?: boolean;
            topics?: string[];
            has_issues?: boolean;
            has_projects?: boolean;
            has_wiki?: boolean;
            has_pages?: boolean;
            has_downloads?: boolean;
            has_discussions?: boolean;
            archived?: boolean;
            disabled?: boolean;
            visibility?: string;
            pushed_at?: string | null;
            created_at?: string | null;
            updated_at?: string | null;
            permissions?: {
                admin?: boolean;
                maintain?: boolean;
                push?: boolean;
                triage?: boolean;
                pull?: boolean;
            };
            role_name?: string;
            temp_clone_token?: string;
            delete_branch_on_merge?: boolean;
            subscribers_count?: number;
            network_count?: number;
            code_of_conduct?: components["schemas"]["code-of-conduct"];
            license?: {
                key?: string;
                name?: string;
                spdx_id?: string;
                url?: string;
                node_id?: string;
            } | null;
            forks?: number;
            open_issues?: number;
            watchers?: number;
            allow_forking?: boolean;
            web_commit_signoff_required?: boolean;
            security_and_analysis?: components["schemas"]["security-and-analysis"];
        }[];
        totalCount: number;
    }>;
    getContents(repository?: string, path?: string): Promise<{
        type: "dir" | "file" | "submodule" | "symlink";
        size: number;
        name: string;
        path: string;
        content?: string;
        sha: string;
        url: string;
        git_url: string | null;
        html_url: string | null;
        download_url: string | null;
        _links: {
            git: string | null;
            html: string | null;
            self: string;
        };
    }[]>;
    updateContent(path: string, content: string | Blob, message?: string, repository?: string): Promise<{
        type: "dir" | "file" | "submodule" | "symlink";
        size: number;
        name: string;
        path: string;
        content?: string;
        sha: string;
        url: string;
        git_url: string | null;
        html_url: string | null;
        download_url: string | null;
        _links: {
            git: string | null;
            html: string | null;
            self: string;
        };
    }>;
    getAllContributors(): Promise<{
        contributions: number;
        login?: string;
        id?: number;
        node_id?: string;
        avatar_url?: string;
        gravatar_id?: string | null;
        url?: string;
        html_url?: string;
        followers_url?: string;
        following_url?: string;
        gists_url?: string;
        starred_url?: string;
        subscriptions_url?: string;
        organizations_url?: string;
        repos_url?: string;
        events_url?: string;
        received_events_url?: string;
        type: string;
        site_admin?: boolean;
        email?: string;
        name?: string;
    }[]>;
}

//# sourceMappingURL=index.d.ts.map
